/*! Built with http://stenciljs.com */
xmlviewercomponent.loadBundle('xml-viewer-component', ['exports'], function (exports) {
    var h = window.xmlviewercomponent.h;
    var Parser = /** @class */ (function () {
        function Parser() {
        }
        Parser.Parse = function (xmlstr) {
            if (typeof DOMParser !== 'undefined') {
                // const DOMParser = new Components.Constructor("@mozilla.org/xmlextras/domparser;1", "nsIDOMParser");
                // var parser = new DOMParser();
                // parser.init();
                // var doc = parser.parseFromString(xmlstr, "application/xml");
                var domDoc = (new DOMParser()).parseFromString(xmlstr, 'application/xml');
                // let's check for errors
                if (domDoc.documentElement.nodeName == "parsererror") {
                    throw new Error('XML parsing error');
                }
                return domDoc;
            }
            return null;
        };
        return Parser;
    }());
    var XmlViewerComponent = /** @class */ (function () {
        function XmlViewerComponent() {
        }
        XmlViewerComponent.prototype.componentDidLoad = function () {
            console.log('The component has been rendered');
        };
        XmlViewerComponent.prototype.prepareXml = function () {
            var xdoc = Parser.Parse(this.xml.trim());
            return xdoc;
        };
        XmlViewerComponent.prototype.renderAttribute = function (attribute) {
            return (h("span", null, "\u00A0", h("span", { class: "attr" }, attribute.name), h("span", null, "=\"", attribute.value, "\"")));
        };
        XmlViewerComponent.prototype.renderNodeValue = function (nodeValue) {
            if (!nodeValue) {
                return null;
            }
            if (nodeValue.length > 150) {
                return (h("ul", null, h("li", null, nodeValue)));
            }
            else {
                return (h("span", null, nodeValue));
            }
        };
        // Rest operator transpiles into sequence.slice() - but sequence is not an array. So I made it by myself
        XmlViewerComponent.prototype.toArray = function (nodes) {
            var arr = [];
            for (var i = 0; i < nodes.length; i++) {
                arr.push(nodes[i]);
            }
            return arr;
        };
        // rendering node. This function calls to itself in recursion way in case of child nodes
        XmlViewerComponent.prototype.renderNode = function (node) {
            var _this = this;
            if (!node) {
                return null;
            }
            var children = this.toArray(node.children); //[...node.children];
            var attributes = this.toArray(node.attributes); //[...node.attributes];
            var nodeValue = node.firstChild ? node.firstChild.nodeValue : null;
            nodeValue = nodeValue ? nodeValue.trim() : null;
            return (h("ul", null, h("li", null, h("span", { class: "element" }, "<"), h("span", { class: "element" }, node.nodeName), attributes.map(function (a) { return _this.renderAttribute(a); }), h("span", { class: "element" }, ">"), this.renderNodeValue(nodeValue), children.map(function (c) { return _this.renderNode(c); }), h("span", { class: "element" }, "</"), h("span", { class: "element" }, node.nodeName), h("span", { class: "element" }, ">"))));
        };
        XmlViewerComponent.prototype.render = function () {
            console.log('rendered');
            if (this.xml === null || this.xml === undefined) {
                return null;
            }
            if (this.xml.length === 0) {
                return null;
            }
            var xdoc = null;
            try {
                xdoc = this.prepareXml();
            }
            catch (e) {
            }
            if (!xdoc || !xdoc.documentElement.childNodes) {
                return (h("code", null, this.xml));
            }
            return (h("code", null, this.renderNode(xdoc.documentElement)));
        };
        Object.defineProperty(XmlViewerComponent, "is", {
            get: function () { return "xml-viewer-component"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(XmlViewerComponent, "encapsulation", {
            get: function () { return "shadow"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(XmlViewerComponent, "properties", {
            get: function () { return { "xml": { "type": String, "attr": "xml" } }; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(XmlViewerComponent, "style", {
            get: function () { return "code[data-xml-viewer-component]{\n    margin:.1rem .25rem 1rem .25rem;\n    padding:0;\n    color:#767676;\n    font-family: monospace, monospace;\n\n    text-shadow: 0 1px #fff;\n    direction: ltr;\n    text-align: left;\n    word-spacing: normal;\n    word-break: normal;\n    word-wrap: normal;\n    line-height: 1.2;\n    -moz-tab-size: 2; -o-tab-size: 2; tab-size: 2;\n    -webkit-hyphens: none; -moz-hyphens: none; -ms-hyphens: none; hyphens: none;\n}\n\ncode[data-xml-viewer-component]   ul[data-xml-viewer-component]{\n    list-style-type: none;\n    margin:0;\n    padding-left:1rem;\n}\n\ncode[data-xml-viewer-component]   span.element[data-xml-viewer-component]{\n    font-weight: bold;\n    color: darkred;\n}\n\ncode[data-xml-viewer-component]   span.attr[data-xml-viewer-component]{\n    font-weight: bold;\n    color: #535353;\n}\n\ncode[data-xml-viewer-component]   span.comment[data-xml-viewer-component]{\n    color: darkgreen;\n}"; },
            enumerable: true,
            configurable: true
        });
        return XmlViewerComponent;
    }());
    exports.XmlViewerComponent = XmlViewerComponent;
    Object.defineProperty(exports, '__esModule', { value: true });
});
